::by Ori
@ECHO OFF
chcp 1252 >NUL

::Const
set "TITLE=Preset Wrapper"
set "VERSION=0.4"

::Config
set checkAdminRights=true
set getUpdatesDaily=true
set sname=zapret
set logFile=logfile.log
set snames=zapret,Zapret,zapret1,Zapret1,zapret2,Zapret2,winws,winws,winws1,winws1,winws2,winws2
set bitsTaskKillTimeout=30

::Init
PUSHD "%~dp0"

::Self-elevation
SetLocal EnableDelayedExpansion
if %checkAdminRights%==true (
	fsutil dirty query %systemdrive% >NUL
	if not !ERRORLEVEL!==0 (
		echo Restarting with elevation...
		timeout /T 2
		wscript elevator.vbs "%~nx0" "%*"
		exit
	)
)
EndLocal

title %TITLE% v%VERSION%
cls

del %logfile%

call :MULTIWRITE Log created at "%date% %time%"
call :MULTIWRITE %TITLE% v%VERSION%
call :MULTIWRITE Staring line: "%*"

::Creating hostlists if they doesn't exist
if not exist "googlevideo.txt" (
	call :MULTIWRITE Creating "googlevideo.txt" hostlist
	echo googlevideo.com>>googlevideo.txt
)
if not exist "hostlist_auto.txt" (
	call :MULTIWRITE Creating "hostlist_auto.txt" hostlist
	echo.>>hostlist_auto.txt
)

::Checking if updates is needed
SetLocal EnableDelayedExpansion
if %getUpdatesDaily%==true (
	call :MULTIWRITE Checking if updates is needed
	if not exist update.state (
		echo 0 >update.state
	)
	set /p update=<update.state
	echo %date%>update.state
	if not "!update!"=="%date%" (
		call :BACKUP "winws.exe"
		call :BACKUP "domains_all_refilter.txt"
	) else (
		call :MULTIWRITE Already updated today
	)
) else (
	call :MULTIWRITE Updates check disabled
)
EndLocal

set "os_arch=32"
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" (set "os_arch=64")
if defined PROCESSOR_ARCHITEW6432 (set "os_arch=64")
call :MULTIWRITE Arch: %os_arch%

::Updating
call :UPDATE_WITH "PowerShell"
if %ERRORLEVEL%==0 (goto MAIN)

call :UPDATE_WITH "cURL"
if %ERRORLEVEL%==0 (goto MAIN)

call :MULTIWRITE Preparing BITS...
sc config BITS start= demand 2>&1 >>%logFile%
bitsadmin /reset 2>&1 >>%logFile%
bitsadmin /create progdwnl 2>&1 >>%logFile%
bitsadmin /setpriority progdwnl HIGH 2>&1 >>%logFile%
bitsadmin /setproxysettings progdwnl NO_PROXY 2>&1 >>%logFile%
call :MULTIWRITE Launching "bits_taskkill.cmd"...
start "" /min bits_taskkill.cmd %bitsTaskKillTimeout%
call :UPDATE_WITH "BITS"
if %ERRORLEVEL%==0 (
	bitsadmin /list 2>&1 >>%logFile%
	bitsadmin /cancel progdwnl 2>&1 >>%logFile%
	goto MAIN
)
bitsadmin /list 2>&1 >>%logFile%
bitsadmin /cancel progdwnl 2>&1 >>%logFile%

call :EXITWITHERROR All download methods have failed

:MAIN
::Services removal
taskkill /IM "winws.exe" /F 2>&1 >>%logFile%
call :REMOVESVC "%snames%"
call :CHECKSVC "%snames%"
if not %ERRORLEVEL%==0 (
	call :EXITWITHERROR didn't manage to delete all services
)

::Choosing preset
set "preset=%~2"
if not defined preset (
	call :CHOOSEPRESET preset
) else (
	if not exist "%preset%" (
		call :EXITWITHERROR can't find "%preset%"
	)
	call :MULTIWRITE Proceeding with preset "%preset%" from args
)

::Parsing preset
set ARGS=
SetLocal EnableDelayedExpansion
for /F "usebackq tokens=* eol=/" %%i in ("%preset%") do (
	call :MULTIWRITE Readed line: "%%i"
	set ARGS=!ARGS!%%i 
)
EndLocal && (call set ARGS=%ARGS%)

::Choosing mode
set "mode=%~1"
SetLocal EnableDelayedExpansion
if defined mode (
	set "mode=%mode:-=%"
	if not "!mode!"=="1" if not "!mode!"=="2" (
		call :EXITWITHERROR incorrect mode "!mode!"
	)
	call :MULTIWRITE Proceeding with mode "!mode!" from args
) else (
	call :CHOOSEMODE mode
)
EndLocal && (set "mode=%mode%")

if %mode%==1 (
	::Starting Zapret
	call :MULTIWRITE Starting Zapret...
	SetLocal EnableDelayedExpansion
	call :MULTIWRITE Command line: "!ARGS!"
	start "Zapret" /min "winws.exe" !ARGS!
	::Checking if successful
	timeout /T 2 >NUL
	tasklist | findstr /I "winws" 2>&1 >>%logFile%
	if not !ERRORLEVEL!==0 (
		EndLocal
		echo.
		call :EXITWITHERROR failed to launch Zapret
	)
	EndLocal
)
if %mode%==2 (
	::Installing Zapret as a service
	call :MULTIWRITE Installing Zapret as a service...
	SetLocal EnableDelayedExpansion
	set ARGS=%ARGS:"=\"%
	call :MULTIWRITE Command line: "!ARGS!"
	sc create %sname% binPath= "\"%~dp0winws.exe\" !ARGS!" DisplayName= "Zapret DPI bypass" start= auto 2>&1 >>%logFile%
	sc description %sname% "Created through %TITLE%; ARGS: !ARGS!" 2>&1 >>%logFile%
	sc start %sname% 2>&1 >>%logFile%
	::Checking if successful
	timeout /T 2 >NUL
	sc query %sname% | findstr /I "running" 2>&1 >>%logFile%
	if not !ERRORLEVEL!==0 (
		EndLocal
		call :REMOVESVC %sname%
		echo.
		call :EXITWITHERROR failed to create and launch Zapret service
	)
	EndLocal
)

echo.
call :MULTIWRITE All done
set "auto=%*"
if not defined auto (
	echo.
	echo Press any button to exit...
	pause>NUL
)
exit /b 0

:MULTIWRITE
SetLocal
set msg=%*
if not defined msg (
	echo.
	if defined logFile (
		echo.>>%logFile%
	)
) else (
	echo %msg%
	if defined logFile (
		echo %msg%>>%logFile%
	)
)
EndLocal
exit /b

:BACKUP
SetLocal
set "filename=%~1"
call :MULTIWRITE Backuping "%filename%"
if exist "%filename%.backup" (
	del "%filename%.backup" 2>&1 >>%logFile%
)
if exist "%filename%" (
	ren "%filename%" "%filename%.backup" 2>&1 >>%logFile%
) else (
	call :MULTIWRITE File "%filename%" not found
)
EndLocal
exit /b 0

:UPDATE_WITH
SetLocal EnableDelayedExpansion
set PROG=%~1
call :MULTIWRITE Updating files using %PROG%...
call :DOWNLOADFILE_%PROG% "https://github.com/1andrevich/Re-filter-lists/blob/main/domains_all.lst?raw=true" "domains_all_refilter.txt"
if not !ERRORLEVEL!==0 (exit /b 1)
if %os_arch%==64 (
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win64/cygwin1.dll?raw=true" "cygwin1.dll"
	if not !ERRORLEVEL!==0 (exit /b 1)
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win64/WinDivert64.sys?raw=true" "WinDivert64.sys"
	if not !ERRORLEVEL!==0 (exit /b 1)
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win64/WinDivert.dll?raw=true" "WinDivert.dll"
	if not !ERRORLEVEL!==0 (exit /b 1)
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win64/winws.exe?raw=true" "winws.exe"
	if not !ERRORLEVEL!==0 (exit /b 1)
) else (
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win32/cygwin1.dll?raw=true" "cygwin1.dll"
	if not !ERRORLEVEL!==0 (exit /b 1)
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win32/WinDivert32.sys?raw=true" "WinDivert32.sys"
	if not !ERRORLEVEL!==0 (exit /b 1)
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win32/WinDivert.dll?raw=true" "WinDivert.dll"
	if not !ERRORLEVEL!==0 (exit /b 1)
	call :DOWNLOADFILE_%PROG% "https://github.com/bol-van/zapret/blob/master/binaries/win32/winws.exe?raw=true" "winws.exe"
	if not !ERRORLEVEL!==0 (exit /b 1)
)
call :MULTIWRITE All files was successfully downloaded
EndLocal
exit /b 0

:DOWNLOADFILE_PowerShell
if not exist "%~2" (
	call :MULTIWRITE Downloading "%~2" from "%~1" using PowerShell
	powershell "$WebRequest=New-Object System.Net.WebClient; $Data=$WebRequest.DownloadFile('%~1','%~2')"
	if exist "%~2" (
		call :MULTIWRITE File "%~2" was successfully downloaded
		exit /b 0
	) else (
		call :MULTIWRITE ERROR: file "%~2" wasn't downloaded
		exit /b 1
	)	
) else (
	call :MULTIWRITE File "%~2" is already in place
	exit /b 0
)

:DOWNLOADFILE_cURL
if not exist "%~2" (
	call :MULTIWRITE Downloading "%~2" from "%~1" using cURL
	curl -m 2 -kLJ "%~1" -o "%~2"
	if exist "%~2" (
		call :MULTIWRITE File "%~2" was successfully downloaded
		exit /b 0
	) else (
		call :MULTIWRITE ERROR: file "%~2" wasn't downloaded
		exit /b 1
	)	
) else (
	call :MULTIWRITE File "%~2" is already in place
	exit /b 0
)

:DOWNLOADFILE_BITS
if not exist "%~2" (
	call :MULTIWRITE Downloading "%~2" from "%~1" using BITS
	start /WAIT bitsadmin /transfer progdwnl %~1 "%~dp0%~2" 2>&1 >>%logFile%
	if exist "%~2" (
		call :MULTIWRITE File "%~2" was successfully downloaded
		exit /b 0
	) else (
		call :MULTIWRITE ERROR: file "%~2" wasn't downloaded
		exit /b 1
	)	
) else (
	call :MULTIWRITE File "%~2" is already in place
	exit /b 0
)

:REMOVESVC
call :MULTIWRITE Starting services removal...
SetLocal
set list=%~1
set list=%list:,= %
for %%i in (%list%) do (
	call :MULTIWRITE Sending stop signal to %%i...
	sc stop %%i 2>&1 >>%logFile%
	call :MULTIWRITE Deleting %%i service...
	sc delete %%i 2>&1 >>%logFile%
)
EndLocal
exit /b 0

:CHECKSVC
call :MULTIWRITE Checking services removal results...
SetLocal EnableDelayedExpansion
set list=%~1
set list=%list:,= %
for %%i in (%list%) do (
	call :MULTIWRITE Querying %%i service...
	sc query %%i 2>&1 >>%logFile%
	if !ERRORLEVEL!==0 (
		call :MULTIWRITE ERROR: service %%i is still present
		EndLocal
		exit /b 1
	)
	call :MULTIWRITE Service %%i doesn't exist
)
call :MULTIWRITE All services have been deleted
EndLocal
exit /b 0

:CHOOSEPRESET
call :MULTIWRITE Choosing preset...
cls

SetLocal EnableDelayedExpansion

set "lettersString=1 2 3 4 5 6 7 8 9 a b c d e f g h i j k l m n o p q r s t u v w x y z"
set lettersLen=-1
for %%i in (%lettersString%) do (
	set /A lettersLen+=1
	set letters[!lettersLen!]=%%i
)
echo Press [0] - Exit
echo.
set count=0
set choices=
for /F "usebackq delims=" %%i in (`dir /b /o:n`) do (
	set "filename=%%i"
	set "filename=!filename:~0,7!"
	if "!filename!"=="Preset_" (
		if !count! LEQ !lettersLen! (
			call set letter=%%letters[!count!]%%
			set /A count+=1
			set "preset[!count!]=%%~fi"
			echo Press [!letter!] - %%i
			set choices=!choices!!letter!
		)
	)
)
if !count!==0 (
	EndLocal
	call :EXITWITHERROR can't find any presets
)

choice /C 0!choices! >NUL
set /A c=!ERRORLEVEL!-1
if !c!==0 (
	call :MULTIWRITE Exiting by users choice
	exit
)
for /L %%i in (1,1,!count!) do (
	if %%i==!c! (
		set "choosedPreset=!preset[%%i]!"
	)
)
call :MULTIWRITE Proceeding with "!choosedPreset!"
EndLocal && (set "%~1=%choosedPreset%")
exit /b 0

:CHOOSEMODE
call :MULTIWRITE Choosing mode...
cls
SetLocal
echo Press [1] - Launch
echo Press [2] - Install as a service
choice /C 12 >NUL
set c=%ERRORLEVEL%
call :MULTIWRITE Proceeding with mode "%c%"
EndLocal && (set "%~1=%c%")
exit /b 0

:EXITWITHERROR
call :MULTIWRITE ERROR: %*
call :MULTIWRITE
echo Press any button to exit...
pause>NUL
exit